/*
 * This file is part of Alida, a Java library for 
 * Advanced Library for Integrated Development of Data Analysis Applications.
 *
 * Copyright (C) 2010 - 2012
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Fore more information on Alida, visit
 *
 *    http://www.informatik.uni-halle.de/alida/
 *
 */

/* 
 * Most recent change(s):
 * 
 * $Rev: 5207 $
 * $Date: 2012-03-14 15:12:09 +0100 (Mi, 14 Mrz 2012) $
 * $Author: moeller $
 * 
 */

package de.unihalle.informatik.Alida.dataio.provider.swing.events;



import de.unihalle.informatik.Alida.operator.events.ALDEvent;

/**
 * Event type for reporting changes of values in provider GUI elements.
 * 
 * @author moeller
 */

public class ALDSwingValueChangeEvent extends ALDEvent {

	/**
	 * Default constructor.
	 *
	 * @param s		Source object of the event.
	 * @param e 	Event type.
	 */
	public ALDSwingValueChangeEvent(Object s) {
	  super(s);
  }
	
	/**
	 * Default constructor with arguments.
	 *
	 * @param s		Source object of the event.
	 * @param e 	Event type.
	 * @param msg	Freely configurable message.
	 */
	public ALDSwingValueChangeEvent(Object s, String msg) {
	  super(s);
	  this.eventMessage = msg;
  }
}
