/*
 * This file is part of MiToBo, the Microscope Image Analysis Toolbox.
 *
 * Copyright (C) 2010
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Fore more information on MiToBo, visit
 *
 *    http://www.informatik.uni-halle.de/mitobo/
 *
 */

/* 
 * Most recent change(s):
 * 
 * $Rev: 5394 $
 * $Date: 2012-04-11 10:11:55 +0200 (Mi, 11. Apr 2012) $
 * $Author: moeller $
 * 
 */

package de.unihalle.informatik.MiToBo.apps.helpers;




/**
 * Defines of enumeration types used in conjunction with cell image analysis.
 * 
 * @author moeller
 */

public class MTBCellImgSegEnums {

	/**
	 * Unit for measurements.
	 * 
	 * @author moeller
	 */
	public static enum MeasureUnit {
		/**
		 * Length and areas are measured in pixels.
		 */
		pixels,
		/**
		 * Length and areas are measured in m, cm, mm, etc.
		 */
		metrics
	}

}
