/*
 * This file is part of MiToBo, the Microscope Image Analysis Toolbox.
 *
 * Copyright (C) 2010 - 2012
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Fore more information on MiToBo, visit
 *
 *    http://www.informatik.uni-halle.de/mitobo/
 *
 */

/* 
 * Most recent change(s):
 * 
 * $Rev: 5329 $
 * $Date: 2012-04-03 15:11:11 +0200 (Di, 03. Apr 2012) $
 * $Author: moeller $
 * 
 */

package de.unihalle.informatik.MiToBo.apps.helpers;



import de.unihalle.informatik.MiToBo.apps.helpers.MTBCellImgSegEnums.MeasureUnit;

/**
 * Interface for unified handling of segmentation results extracted by 
 * particle, cell or nucleus detectors.
 * 
 * @author moeller
 */

public interface MTBCellImgSegResult_Interface {

	/**
	 * Returns the name of the processed image.
	 */
	public abstract String getImageName(); 
	
	/**
	 * Returns the unit of measurements.
	 */
	public abstract MeasureUnit getMeasurementUnit();
	
}
