package de.unihalle.informatik.MiToBo.core.gui.editor;

import javax.swing.JOptionPane;



import de.unihalle.informatik.Alida.annotations.ALDAOperator;
import de.unihalle.informatik.Alida.annotations.ALDAOperator.Level;
import de.unihalle.informatik.Alida.exceptions.ALDOperatorException;
import de.unihalle.informatik.Alida.exceptions.ALDProcessingDAGException;
import de.unihalle.informatik.Alida.gui.ALDOperatorControlFrame;
import de.unihalle.informatik.Alida.gui.editor.ALDEditorFrame;
import de.unihalle.informatik.MiToBo.core.gui.MTBOperatorControlFrame;

/**
 * Main Window for graphical programming in Alida/Mitobo.
 * 
 * @author Birgit Möller
 */

@ALDAOperator(genericExecutionMode = ALDAOperator.ExecutionMode.NONE, 
	level = Level.APPLICATION)
public class MTBEditorFrame extends ALDEditorFrame {
	/**
	 * Main window for interactions.
	 */
//	private JFrame mainWindow;

	/**
	 * Builds the operator tree.
	 */
//	private ALDOperatorChooserTree opTree;

	/**
	 * Scroll pane displaying the operator tree.
	 */
//	private JScrollPane opTreePane;

	/**
	 * Tree of available operators.
	 */
//	private JTree Tree;

	/**
	 * Graph where the nodes represents operators.
	 */
//	private mxGraph opGraph;

	/**
	 * Component which holds the graph.
	 */
//	private mxGraphComponent graphComponent;
//
//	// ...
//	private HashMap<String, mxCell> nodeMap = new HashMap<String, mxCell>();
//
//	private HashMap<mxCell, ALDOperatorDescriptor> opDescrMap = new HashMap<mxCell, ALDOperatorDescriptor>();
//
//	// TODO
//	private String tempOpNamePath = null;
//	private String tempOpName = null;
//	private boolean runOnlyNode = false;

	/**
	 * Default constructor
	 * 
	 * @throws ALDOperatorException
	 */
	public MTBEditorFrame() throws ALDOperatorException {
		super();
	}

	@Override
	protected void operate() throws ALDOperatorException,
			ALDProcessingDAGException {

		super.operate();
		this.mainWindow.setTitle("MTBEditorFrame: NewGraph");
	}
	
	@Override
  protected MTBOperatorControlFrame getControlFrame(String opName) {
  	MTBOperatorControlFrame frame = null;
		try {
			frame = new MTBOperatorControlFrame(opName);
		} catch (ALDOperatorException e) {
			Object[] okOption = { "OK" };
			JOptionPane.showOptionDialog(
					null,
					"Could not instante chosen operator \"" + name + "\"\n" +
				  "Something seems to be wrong with its class implementation...",
				  "Warning", JOptionPane.DEFAULT_OPTION,
				  JOptionPane.WARNING_MESSAGE, null, okOption, okOption[0]);
			frame = null;
		}
  	return frame;
	}

		//
//		// set up main window
//		mainWindow = new JFrame("ALDEditorFrame: NewGraph");
//		mainWindow.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
//		mainWindow.setSize(500, 500);
//
//		// build operator tree and add tree view to main panel
//		Collection<String> standardOps = 
//				ALDClassInfo.lookupOperators(ALDAOperator.Level.STANDARD, 
//																		 ALDAOperator.ExecutionMode.SWING);
//		//standardOps.addAll( additionalOperators( ALDAOperator.Level.STANDARD));
//		Collection<String> applicationOps = 
//				ALDClassInfo.lookupOperators(ALDAOperator.Level.APPLICATION, 
//																		 ALDAOperator.ExecutionMode.SWING);
//		// applicationOps.addAll( additionalOperators( ALDAOperator.Level.APPLICATION));
//		this.opTree = new ALDOperatorChooserTree(standardOps, applicationOps);
////		Tree = opTree.getTree();
////		Tree.addMouseListener(new TreeMouseAdapter(this));
//		this.opTreePane = new JScrollPane(this.opTree);
//		mainWindow.add(BorderLayout.WEST, this.opTreePane);
//
//		// initialize the graph for the operators
//		opGraph = new mxGraph() {
//			public String getToolTipForCell(Object cell) {
//				mxCell port = (mxCell) cell;
//				if (port.isVertex() && port.isConnectable()) {
//					ALDOperatorDescriptor opDescr = opDescrMap.get(nodeMap
//							.get(port.getParent().getValue().toString()));
//					ALDParameterDescriptor parDescr = opDescr
//							.getParameterDescriptor(((ALDPort) port.getValue())
//									.getParName());
//					String toolTip = "<html>" + "Name: " + parDescr.getLabel()
//							+ "<br>" + "Class: "
//							+ parDescr.getMyclass().getSimpleName() + "<br>"
//							+ parDescr.getExplanation() + "</html>";
//					return toolTip;
//				}
//
//				return null;
//			}
//
//			public boolean isCellFoldable(Object cell, boolean collapse) {
//				return false;
//			}
//		};
//		opGraph.setMinimumGraphSize(new mxRectangle(0, 0, 500, 500));
//		opGraph.setAllowDanglingEdges(false);
//		opGraph.setCellsEditable(false);
//
//		// add graph to the component and finally to the panel
//		graphComponent = new mxGraphComponent(opGraph);
//		graphComponent.getGraphControl().addMouseListener(
//				new GraphMouseAdapter(this));
//		graphComponent.getConnectionHandler().addListener(mxEvent.CONNECT,
//				new EdgeConnectListener());
//
//		graphComponent.setFocusable(true);
//		graphComponent.setToolTips(true);
//
//		mainWindow.getContentPane().add(graphComponent);
//
//		// add a nice menu bar
//		JMenuBar mainWindowMenu = new JMenuBar();
//		JMenu fileM = new JMenu("File");
//		JMenuItem newItem = new JMenuItem("New");
//		newItem.setActionCommand("new");
//		newItem.addActionListener(this);
//		JMenuItem saveItem = new JMenuItem("Save");
//		saveItem.setActionCommand("save");
//		saveItem.addActionListener(this);
//		JMenuItem loadItem = new JMenuItem("Load");
//		loadItem.setActionCommand("load");
//		loadItem.addActionListener(this);
//		JMenuItem quitItem = new JMenuItem("Quit");
//		quitItem.setActionCommand("quit");
//		quitItem.addActionListener(this);
//		fileM.add(newItem);
//		fileM.add(saveItem);
//		fileM.add(loadItem);
//		fileM.add(quitItem);
//
//		JMenu opSelectM = new JMenu("Operator Level");
//		ButtonGroup operatorLevelGroup = new ButtonGroup();
//		JRadioButtonMenuItem radioItemApplication = new JRadioButtonMenuItem(
//				"Application");
//		radioItemApplication.setActionCommand("viewApps");
//		radioItemApplication.addActionListener(this);
//		radioItemApplication.setSelected(true);
//		JRadioButtonMenuItem radioItemStandard = new JRadioButtonMenuItem(
//				"Standard");
//		radioItemStandard.setActionCommand("viewStd");
//		radioItemStandard.addActionListener(this);
//		operatorLevelGroup.add(radioItemApplication);
//		operatorLevelGroup.add(radioItemStandard);
//		opSelectM.add(radioItemApplication);
//		opSelectM.add(radioItemStandard);
//
//		// add to menu bar and finally to the main window
//		mainWindowMenu.add(fileM);
//		mainWindowMenu.add(opSelectM);
//		mainWindow.setJMenuBar(mainWindowMenu);
//
//		// set up main window
//		mainWindow.pack();
//		mainWindow.setVisible(true);
//	}

	/**
	 * Show file dialog to save or load a workflow.
	 * 
	 * @param save
	 *            True if workflow has to be saved.
	 * @return Selected file.
	 */
//	private File showDialog(boolean save) {
//		File file = null;
//		/*
//		 * Locale loc = Locale.ENGLISH; JFileChooser.setDefaultLocale(loc);
//		 */
//		JFileChooser fileDialog = new JFileChooser();
//
//		if (save)
//			fileDialog.setDialogType(JFileChooser.SAVE_DIALOG);
//		else
//			fileDialog.setDialogType(JFileChooser.OPEN_DIALOG);
//
//		fileDialog.setCurrentDirectory(new File(System.getProperty("user.home")
//				+ "/Desktop"));
//		fileDialog.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
//
//		int returnVal = fileDialog.showOpenDialog(null);
//		if (returnVal == JFileChooser.APPROVE_OPTION) {
//			file = fileDialog.getSelectedFile();
//			if (file.listFiles().length != 0 && save) {
//				for (File files : file.listFiles())
//					files.delete();
//			}
//		}
//		return file;
//	}

	// TODO comments
//	private void saveWorkflow(File file) {
//		mxCodec enc = new mxCodec();
//		mxCodecRegistry
//				.addPackage("de.unihalle.informatik.Alida.gui.editor.ALDPort");
//		mxCodecRegistry.register(new mxObjectCodec(new ALDPort()));
//		try {
//			for (mxCell cell : nodeMap.values()) {
//				ALDOperatorDescriptor opDescr = opDescrMap.get(cell);
//				opDescr.getOperatorControlFrame().configuration(
//						file + "/" + cell.getValue().toString() + ".xml", true);
//			}
//			mxUtils.writeFile(
//					mxXmlUtils.getXml(enc.encode(opGraph.getModel())),
//					file.getAbsolutePath() + "/Workflow.xml");
//			this.mainWindow.setTitle("ALDEditorFrame: "
//					+ file.getAbsolutePath());
//		} catch (IOException e1) {
//			// TODO Auto-generated catch block
//			e1.printStackTrace();
//		} catch (ALDDataIOProviderException e2) {
//			// TODO Auto-generated catch block
//			e2.printStackTrace();
//		} catch (ALDOperatorException e3) {
//			// TODO Auto-generated catch block
//			e3.printStackTrace();
//		}
//	}

	// TODO comments
//	private void loadWorkflow(File file) {
//		Document document;
//		try {
//			mxCodecRegistry
//					.addPackage("de.unihalle.informatik.Alida.gui.editor.ALDPort");
//			mxCodecRegistry.register(new mxObjectCodec(new ALDPort()));
//			document = mxXmlUtils.parseXml(mxUtils.readFile(file
//					.getAbsolutePath() + "/Workflow.xml"));
//			mxCodec codec = new mxCodec(document);
//			codec.decode(document.getDocumentElement(), opGraph.getModel());
//			this.mainWindow.setTitle("ALDEditorFrame: "
//					+ file.getAbsolutePath());
//
//			nodeMap.clear();
//			opDescrMap.clear();
//
//			for (Object child : opGraph.getChildCells(opGraph
//					.getDefaultParent())) {
//				mxCell cell = (mxCell) child;
//				if (cell.isVertex()) {
//					registerNode(cell, file);
//				} else if (cell.isEdge()) {
//					registerEdge(cell);
//				}
//			}
//
//		} catch (IOException e1) {
//			// TODO Auto-generated catch block
//			e1.printStackTrace();
//		} catch (ALDOperatorException e2) {
//			// TODO Auto-generated catch block
//			e2.printStackTrace();
//		}
//	}

//	@Override
//	public void actionPerformed(ActionEvent e) {
//		String command = e.getActionCommand();
//
//		/* handle tree view options */
//		if (command.equals("viewApps")) {
//			mainWindow.remove(opTreePane);
//			opTree.setLevel(ALDAOperator.Level.APPLICATION);
////			Tree = opTree.getTree();
////			Tree.addMouseListener(new TreeMouseAdapter(this));
////			opTreePane = new JScrollPane(Tree);
//			mainWindow.add(BorderLayout.WEST, opTreePane);
//			mainWindow.setVisible(false);
//			mainWindow.setVisible(true);
//		} else if (command.equals("viewStd")) {
//			mainWindow.remove(opTreePane);
//			opTree.setLevel(ALDAOperator.Level.STANDARD);
////			Tree = opTree.getTree();
////			Tree.addMouseListener(new TreeMouseAdapter(this));
////			opTreePane = new JScrollPane(Tree);
//			mainWindow.add(BorderLayout.WEST, opTreePane);
//			mainWindow.setVisible(false);
//			mainWindow.setVisible(true);
//		}
//
//		else if (command.equals("new")) {
//			// TODO remove everything
//			opDescrMap.clear();
//			nodeMap.clear();
//			opGraph.removeCells(opGraph.getChildVertices(opGraph
//					.getDefaultParent()));
//		}
//
//		// save button has been pressed
//		else if (command.equals("save")) {
//			final File file = showDialog(true);
//			if (file != null) {
//				try {
//					Thread tSave = new Thread() {
//						public void run() {
//							saveWorkflow(file);
//						}
//					};
//					tSave.start();
//					tSave.join();
//					JOptionPane.showMessageDialog(null, "Save successful",
//							"Message", JOptionPane.OK_CANCEL_OPTION);
//				} catch (InterruptedException e1) {
//					// TODO Auto-generated catch block
//					e1.printStackTrace();
//				}
//			}
//		}
//
//		// load button has been pressed
//		else if (command.equals("load")) {
//			final File file = showDialog(false);
//			if (file != null) {
//				try {
//					Thread tLoad = new Thread() {
//						public void run() {
//							loadWorkflow(file);
//						}
//					};
//					tLoad.start();
//					tLoad.join();
//					JOptionPane.showMessageDialog(null, "Load successful",
//							"Message", JOptionPane.OK_CANCEL_OPTION);
//				} catch (InterruptedException e1) {
//					// TODO Auto-generated catch block
//					e1.printStackTrace();
//				}
//			}
//		}
//
//		// quit button has been pressed
//		else if (command.equals("quit")) {
//			mainWindow.setVisible(false);
//		}
//	}

	/**
	 * Register a new node representing an operator.
	 * 
	 * @param cell
	 *            Node to be registered.
	 * @param file
	 *            File with operator configuration.
	 * 
	 * @throws ALDOperatorException
	 */
//	private void registerNode(mxCell cell, File file)
//			throws ALDOperatorException {
//		ALDOperatorDescriptor opDescr = new ALDOperatorDescriptor(
//				new ALDOperatorControlFrame(cell.getId().split("@")[0]));
//		opDescr.getOperatorControlFrame().setEditorFrame(this,
//				cell.getValue().toString());
//		ALDOperator op = opDescr.getOperatorControlFrame().getALDOperator();
//		nodeMap.put(cell.getValue().toString(), cell);
//		opDescrMap.put(cell, opDescr);
//
//		if (cell.getStyle().contains("strokeColor=green"))
//			cell.setStyle(cell.getStyle().replace("strokeColor=green",
//					"strokeColor=yellow"));
//
//		for (int i = 0; i < cell.getChildCount(); i++) {
//			mxCell port = (mxCell) cell.getChildAt(i);
//			opDescr.addParameter(((ALDPort) port.getValue()).getParName(), op
//					.getParameterDescriptor(((ALDPort) port.getValue())
//							.getParName()), port);
//		}
//		try {
//			opDescr.getOperatorControlFrame().configuration(
//					file + "/" + cell.getValue().toString() + ".xml", false);
//		} catch (ALDDataIOProviderException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//	}

	/**
	 * Register a new edge representing a link.
	 * 
	 * @param edge
	 *            Edge to be registered.
	 */
//	private void registerEdge(mxCell edge) {
//		String linkSource = edge.getSource().getParent().getValue().toString()
//				+ "@" + ((ALDPort) edge.getSource().getValue()).getParName();
//		String linkTarget = edge.getTarget().getParent().getValue().toString()
//				+ "@" + ((ALDPort) edge.getTarget().getValue()).getParName();
//		ALDOperatorDescriptor opDescrTarget = opDescrMap.get(edge.getTarget()
//				.getParent());
//		ALDOpParameterDescriptor descr = opDescrTarget
//				.getParameterDescriptor(((ALDPort) edge.getTarget().getValue())
//						.getParName());
//		descr.setLink(true);
//		opDescrTarget.getOperatorControlFrame().changePanel(linkTarget,
//				linkSource);
//		opDescrMap.get(edge.getSource().getParent()).addChild(
//				edge.getTarget().getParent().getValue().toString());
//	}

	/**
	 * Builds a node with the operator at opNamePath and the name opName.
	 * 
	 * @param opNamePath
	 *            Path of the operator.
	 * @param opName
	 *            Name of the operator.
	 * @param posX
	 *            X-Position of the new node.
	 * @param posY
	 *            Y-Position of the new node.
	 * @return Node which represents operator.
	 * 
	 * @throws ALDOperatorException
	 */
//	private mxCell buildNode(String opNamePath, String opName, double posX,
//			double posY) throws ALDOperatorException {
//		if (nodeMap.containsKey(opName)) {
//			int i = 2;
//			while (nodeMap.containsKey(opName + "_" + i)) {
//				i++;
//			}
//			opNamePath = opNamePath + "@" + i;
//			opName = opName + "_" + i;
//		}
//
//		ALDOperatorDescriptor opDescr = new ALDOperatorDescriptor(
//				new ALDOperatorControlFrame(opNamePath.split("@")[0]));
//		opDescr.getOperatorControlFrame().setEditorFrame(this, opName);
//		ALDOperator op = opDescr.getOperatorControlFrame().getALDOperator();
//
//		int height = (op.getInNames(null).size() + op.getInOutNames(null)
//				.size()) * 20;
//		mxCell v = (mxCell) opGraph.insertVertex(opGraph.getDefaultParent(),
//				opNamePath, opName, posX, posY, 160, height);
//		v.setConnectable(false);
//		nodeMap.put(opName, v);
//		opDescrMap.put(v, opDescr);
//
//		v.setStyle("verticalLabelPosition=top;verticalAlign=bottom;fontStyle=1;strokeWidth=3.0;strokeColor=red");
//
//		double countIn = 1 / ((double) (op.getInNames(null).size() + op
//				.getInOutNames(null).size()) + 1);
//		int posIn = 1;
//		double countOut = 1 / ((double) (op.getOutNames().size() + op
//				.getInOutNames(null).size()) + 1);
//		int posOut = 1;
//
//		// build a port for each input parameter
//		for (String s : op.getInNames(null)) {
//			double x = countIn * posIn;
//			mxGeometry geo = new mxGeometry(0, x, 10, 10);
//			geo.setOffset(new mxPoint(-5, -5));
//			geo.setRelative(true);
//			ALDPort obj = new ALDPort(s);
//			mxCell port = new mxCell(obj, geo, null);
//			opDescr.addParameter(s, op.getParameterDescriptor(s), port);
//
//			ALDOpParameterDescriptor descr = opDescr.getParameterDescriptor(s);
//
//			// required parameters are blue and not required are yellow
//			if (descr.isRequired()) {
//				port.setStyle("labelPosition=right;align=left;shape=ellipse;perimter=ellipsePerimeter");
//			} else if (!descr.getSupplemental().booleanValue()) {
//				port.setStyle("labelPosition=right;align=left;fillColor=yellow;shape=ellipse;perimter=ellipsePerimeter");
//			} else {
//				port.setStyle("labelPosition=right;align=left;fillColor=red;shape=ellipse;perimter=ellipsePerimeter");
//			}
//
//			port.setVertex(true);
//			opGraph.addCell(port, v);
//
//			if (descr.getHandlingMode() != Parameter.ExpertMode.STANDARD)
//				port.setVisible(false);
//
//			posIn++;
//		}
//
//		// build a port for each output parameter
//		for (String s : op.getOutNames()) {
//			double x = countOut * posOut;
//			mxGeometry geo = new mxGeometry(1, x, 10, 10);
//			geo.setOffset(new mxPoint(-5, -5));
//			geo.setRelative(true);
//			ALDPort obj = new ALDPort(s);
//			mxCell port = new mxCell(obj, geo,
//					"labelPosition=left;align=right;shape=ellipse;perimter=ellipsePerimeter");
//			opDescr.addParameter(s, op.getParameterDescriptor(s), port);
//
//			port.setVertex(true);
//			opGraph.addCell(port, v);
//
//			posOut++;
//		}
//
//		// build a port for each inout parameter
//		for (String s : op.getInOutNames(null)) {
//			double x = countIn * posIn;
//			mxGeometry geo1 = new mxGeometry(1, x, 10, 10);
//			geo1.setOffset(new mxPoint(-5, -5));
//			geo1.setRelative(true);
//			ALDPort obj1 = new ALDPort(s);
//			mxCell port1 = new mxCell(obj1, geo1,
//					"labelPosition=left;align=right");
//
//			mxGeometry geo2 = new mxGeometry(0, x, 10, 10);
//			geo2.setOffset(new mxPoint(-5, -5));
//			geo2.setRelative(true);
//			ALDPort obj2 = new ALDPort(s);
//			mxCell port2 = new mxCell(obj2, geo2,
//					"labelPosition=right;align=left");
//
//			opDescr.addParameter(s, op.getParameterDescriptor(s), port1);
//			opDescr.addParameter(s, op.getParameterDescriptor(s), port2);
//
//			port1.setVertex(true);
//			opGraph.addCell(port1, v);
//			port2.setVertex(true);
//			opGraph.addCell(port2, v);
//
//			posIn++;
//		}
//
//		opGraph.refresh();
//		return v;
//	}

	/**
	 * Run the node representing an operator.
	 * 
	 * @param node
	 *            Node to run.
	 * @param wait
	 *            True if operator has to wait until finished.
	 * @return True if operator run was successful.
	 */
//	public boolean runOpNode(String node, boolean wait) {
//		mxCell cell = nodeMap.get(node);
//		if (cell.getStyle().contains("strokeColor=yellow")
//				|| cell.getStyle().contains("strokeColor=green")) {
//			ALDOperatorDescriptor opDescr = opDescrMap.get(cell);
//
//			if (opDescr.getChildList().isEmpty())
//				opDescr.getOperatorControlFrame().setProviderInteractionLevel(
//						ProviderInteractionLevel.ALL_ALLOWED);
//			else
//				opDescr.getOperatorControlFrame().setProviderInteractionLevel(
//						ProviderInteractionLevel.ALL_FORBIDDEN);
//
//			try {
//				if (opDescr.getOperatorControlFrame().runOperator(wait)) {
//					return true;
//				}
//			} catch (ALDOperatorException e) {
//				JOptionPane.showMessageDialog(null, "Running node \"" + node
//						+ "\" failed!" + " Reason: \n" + e.getCommentString(),
//						"Warning", JOptionPane.OK_CANCEL_OPTION);
//			}
//		} else {
//			if (cell.getStyle().contains("strokeColor=red"))
//				JOptionPane.showMessageDialog(null, "The node " + node
//						+ " isn't configured", "Warning",
//						JOptionPane.OK_CANCEL_OPTION);
//		}
//		return false;
//	}

	/**
	 * Run a graph with operations.
	 * 
	 * @param start
	 *            Node to start with.
	 */
//	public void runOpGraph(String start) {
//		ALDOperatorDescriptor opDescr = opDescrMap.get(nodeMap.get(start));
//		if (!runOnlyNode) {
//			if (opDescr.getChildList().isEmpty())
//				opDescr.getOperatorControlFrame().showResult();
//			for (String s : opDescr.getChildList()) {
//				runOpNode(s, false);
//			}
//		} else
//			opDescr.getOperatorControlFrame().showResult();
//	}
//
//	// TODO
//	public void setToConfigured(String node, boolean ready) {
//		mxCell cell = nodeMap.get(node);
//		if (ready) {
//			cell.setStyle(cell.getStyle().replace("strokeColor=red",
//					"strokeColor=yellow"));
//			cell.setStyle(cell.getStyle().replace("strokeColor=green",
//					"strokeColor=yellow"));
//		} else {
//			cell.setStyle(cell.getStyle().replace("strokeColor=yellow",
//					"strokeColor=red"));
//			cell.setStyle(cell.getStyle().replace("strokeColor=green",
//					"strokeColor=red"));
//		}
//		opGraph.refresh();
//	}

//	public void setToInExecution(String node, boolean executed) {
//		mxCell cell = nodeMap.get(node);
//		if (executed)
//			cell.setStyle(cell.getStyle().replace("strokeColor=blue",
//					"strokeColor=green"));
//		else
//			cell.setStyle(cell.getStyle().replace("strokeColor=yellow",
//					"strokeColor=blue"));
//		opGraph.refresh();
//	}

	/**
	 * Get the value of a given link.
	 * 
	 * @param link
	 *            Link with operator and parameter.
	 * @return Value of the given link.
	 */
//	public Object getValue(String link) {
//		String[] linkParts = link.split("@");
//		ALDOperatorControlFrame frame = opDescrMap.get(
//				nodeMap.get(linkParts[0])).getOperatorControlFrame();
//		Object value = null;
//		try {
//			value = frame.getALDOperator().getParameter(linkParts[1]);
//		} catch (ALDOperatorException e) {
//			JOptionPane.showMessageDialog(null, "Getting value of \""
//					+ linkParts[1] + " in " + linkParts[0] + "\" failed!"
//					+ " Reason: \n" + e.getCommentString(), "Warning",
//					JOptionPane.OK_CANCEL_OPTION);
//		}
//		return value;
//	}

	/**
	 * Validate a edge between two ports.
	 * 
	 * @param linkSource
	 *            Source of the edge.
	 * @param linkTarget
	 *            Target of the edge.
	 * @return False if validation failed.
	 */
//	public boolean validateLink(String linkSource, String linkTarget) {
//		String[] sourceSplit = linkSource.split("@");
//		String[] targetSplit = linkTarget.split("@");
//
//		// Check if node exists
//		if (!nodeMap.containsKey(sourceSplit[0])) {
//			JOptionPane.showMessageDialog(null, "This node doesn't exist",
//					"Warning", JOptionPane.OK_CANCEL_OPTION);
//			return false;
//		}
//
//		ALDOperatorDescriptor opDescrSource = opDescrMap.get(nodeMap
//				.get(sourceSplit[0]));
//		ALDOperatorDescriptor opDescrTarget = opDescrMap.get(nodeMap
//				.get(targetSplit[0]));
//
//		// Check if parameter exists
//		if (opDescrSource.getPort(sourceSplit[1]) == null) {
//			JOptionPane.showMessageDialog(null, "This parameter doesn't exist",
//					"Warning", JOptionPane.OK_CANCEL_OPTION);
//			return false;
//		}
//
//		// Check if parameter can be linked depending on parameter direction
//		if (opDescrSource.getParameterDescriptor(sourceSplit[1]).getDirection() == Direction.OUT
//				&& (opDescrTarget.getParameterDescriptor(targetSplit[1])
//						.getDirection() == Direction.IN || opDescrTarget
//						.getParameterDescriptor(targetSplit[1]).getDirection() == Direction.INOUT)
//				|| opDescrSource.getParameterDescriptor(sourceSplit[1])
//						.getDirection() == Direction.INOUT
//				&& (opDescrTarget.getParameterDescriptor(targetSplit[1])
//						.getDirection() == Direction.IN || opDescrTarget
//						.getParameterDescriptor(targetSplit[1]).getDirection() == Direction.INOUT)) {
//			// Check if parameter can be linked depending on parameter class
//			// if (opDescrSource.getParameterDescriptor(sourceSplit[1])
//			// .getMyclass() == opDescrTarget.getParameterDescriptor(
//			// targetSplit[1]).getMyclass()) {
//			if (opDescrTarget
//					.getParameterDescriptor(targetSplit[1])
//					.getMyclass()
//					.isAssignableFrom(
//							opDescrSource
//									.getParameterDescriptor(sourceSplit[1])
//									.getMyclass())) {
//				return true;
//			} else {
//				JOptionPane.showMessageDialog(null, "You can't connect "
//						+ opDescrSource.getParameterDescriptor(sourceSplit[1])
//								.getMyclass().getSimpleName()
//						+ " and "
//						+ opDescrTarget.getParameterDescriptor(targetSplit[1])
//								.getMyclass().getSimpleName(), "Warning",
//						JOptionPane.OK_CANCEL_OPTION);
//			}
//		} else {
//			JOptionPane.showMessageDialog(null, "You can't connect "
//					+ opDescrSource.getParameterDescriptor(sourceSplit[1])
//							.getDirection()
//					+ " and "
//					+ opDescrTarget.getParameterDescriptor(targetSplit[1])
//							.getDirection(), "Warning",
//					JOptionPane.OK_CANCEL_OPTION);
//		}
//
//		return false;
//	}

	/**
	 * Draw an edge between two ports.
	 * 
	 * @param linkSource
	 *            Source of the edge.
	 * @param linkTarget
	 *            Target of the edge.
	 */
//	public void drawEdge(String linkSource, String linkTarget) {
//		ALDOperatorDescriptor opDescr = opDescrMap.get(nodeMap.get(linkSource
//				.split("@")[0]));
//
//		mxCell source = opDescr.getPort(linkSource.split("@")[1]);
//		mxCell target = opDescrMap.get(nodeMap.get(linkTarget.split("@")[0]))
//				.getPort(linkTarget.split("@")[1]);
//
//		if (target.getEdgeCount() != 0) {
//			mxCell edge = (mxCell) opGraph.getIncomingEdges(target)[0];
//			String linkSource1 = edge.getSource().getParent().getValue()
//					.toString()
//					+ "@"
//					+ ((ALDPort) edge.getSource().getValue()).getParName();
//			String linkTarget1 = edge.getTarget().getParent().getValue()
//					.toString()
//					+ "@"
//					+ ((ALDPort) edge.getTarget().getValue()).getParName();
//			if (!(linkSource1.equals(linkSource) && linkTarget1
//					.equals(linkTarget)))
//				removeEdge(edge, true);
//			else
//				return;
//		}
//
//		opGraph.insertEdge(opGraph.getDefaultParent(), null, null, source,
//				target);
//		opDescr.addChild(linkTarget.split("@")[0]);
//	}

	/**
	 * Remove an edge.
	 * 
	 * @param edge
	 *            Edge to be removed.
	 * @param change
	 *            True if link has changed and false if removed.
	 */
//	private void removeEdge(mxCell edge, boolean change) {
//		ALDOperatorDescriptor opDescr = opDescrMap.get(edge.getSource()
//				.getParent());
//		opDescr.removeChild(edge.getTarget().getParent().getValue().toString());
//
//		ALDOpParameterDescriptor descr = opDescrMap.get(
//				edge.getTarget().getParent()).getParameterDescriptor(
//				((ALDPort) edge.getTarget().getValue()).getParName());
//		String link = edge.getTarget().getParent().getValue().toString() + "@"
//				+ ((ALDPort) edge.getTarget().getValue()).getParName();
//		if (!change)
//			descr.setLink(false);
//		opDescrMap.get(edge.getTarget().getParent()).getOperatorControlFrame()
//				.changePanel(link, null);
//
//		opGraph.getModel().remove(edge);
//	}

	/**
	 * MouseListener for the operator tree.
	 */
//	class TreeMouseAdapter extends MouseAdapter {
//
//		ActionListener listener;
//
//		TreeMouseAdapter(ActionListener list) {
//			this.listener = list;
//		}
//
//		@Override
//		public void mouseClicked(MouseEvent e) {
//			if (e.getClickCount() == 1) {
////				if (opTree.getOpNamePath() != null) {
////					tempOpNamePath = opTree.getOpNamePath();
////					tempOpName = opTree.getOpName();
////					opTreePane.setCursor(new Cursor(Cursor.HAND_CURSOR));
////					graphComponent.getGraphHandler().DEFAULT_CURSOR = new Cursor(
////							Cursor.HAND_CURSOR);
////				}
//			if (opTree.getLastSelectedPathComponent() != null) {
//			tempOpNamePath = opTree.getLastSelectedPathComponent().toString();
//			tempOpName = opTree.getLastSelectedPathComponent().toString();
//			opTreePane.setCursor(new Cursor(Cursor.HAND_CURSOR));
//			graphComponent.getGraphHandler().DEFAULT_CURSOR = new Cursor(
//					Cursor.HAND_CURSOR);
//		}
//			}
//
//			// on double-click add selected operator to graph
//			if (e.getClickCount() == 2) {
//
//				if (opTree.getLastSelectedPathComponent() != null) {
//					try {
//						buildNode(opTree.getLastSelectedPathComponent().toString(), 
//								opTree.getLastSelectedPathComponent().toString(),
//								50, 50);
//						tempOpNamePath = null;
//						tempOpName = null;
//						opTreePane.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
//						graphComponent.getGraphHandler().DEFAULT_CURSOR = new Cursor(
//								Cursor.DEFAULT_CURSOR);
//					} catch (ALDOperatorException e1) {
//						JOptionPane.showMessageDialog(null, "Building node \""
//								+ opTree.getLastSelectedPathComponent() + "\" failed!"
//								+ " Reason: \n" + e1.getCommentString(),
//								"Warning", JOptionPane.OK_CANCEL_OPTION);
//					}
//				}
//			}
//		}
//	}

	/**
	 * MouseListener for the graph with operators.
	 */
//	class GraphMouseAdapter extends MouseAdapter {
//
//		ActionListener listener;
//
//		GraphMouseAdapter(ActionListener list) {
//			this.listener = list;
//		}
//
//		@Override
//		public void mousePressed(MouseEvent e) {
//			if (e.getButton() == MouseEvent.BUTTON1 && tempOpName != null
//					&& tempOpNamePath != null) {
//				try {
//					buildNode(tempOpNamePath, tempOpName, e.getX(), e.getY());
//					tempOpNamePath = null;
//					tempOpName = null;
//					opTreePane.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
//					graphComponent.getGraphHandler().DEFAULT_CURSOR = new Cursor(
//							Cursor.DEFAULT_CURSOR);
//				} catch (ALDOperatorException e1) {
//					JOptionPane.showMessageDialog(null, "Building node \""
//							+ opTree.getLastSelectedPathComponent() + "\" failed!" + " Reason: \n"
//							+ e1.getCommentString(), "Warning",
//							JOptionPane.OK_CANCEL_OPTION);
//				}
//			}
//
//			// on right-click open context menu
//			if (e.getButton() == MouseEvent.BUTTON3) {
//				mxCell cell = (mxCell) graphComponent.getCellAt(e.getX(),
//						e.getY());
//				if (cell != null) {
//					if (cell.isVertex() && !cell.isConnectable()
//							|| cell.isEdge()) {
//						PopUpMenu menu = new PopUpMenu(e.getX(), e.getY());
//						menu.show(e.getComponent(), e.getX(), e.getY());
//					} else {
//						ALDOperatorDescriptor opDescr = opDescrMap.get(cell
//								.getParent());
//						ALDOpParameterDescriptor descr = opDescr
//								.getParameterDescriptor(((ALDPort) cell
//										.getValue()).getParName());
//						String link = cell.getParent().getValue().toString()
//								+ "@"
//								+ ((ALDPort) cell.getValue()).getParName();
//						if (descr.getDirection() == Direction.IN
//								|| descr.getDirection() == Direction.INOUT) {
//							if (descr.isLink())
//								descr.setLink(false);
//							else
//								descr.setLink(true);
//							opDescr.getOperatorControlFrame().changePanel(link,
//									null);
//							opDescr.getOperatorControlFrame().setVisible(true);
//						} else {
//							JOptionPane.showMessageDialog(null,
//									"This parameter is an output!", "Warning",
//									JOptionPane.OK_CANCEL_OPTION);
//						}
//					}
//				}
//			}
//		}
//	}

	/**
	 * ConnectionListener for drawing an edge.
	 */
//	class EdgeConnectListener implements mxIEventListener {
//		public void invoke(Object sender, mxEventObject event) {
//			mxCell edge = (mxCell) event.getProperty("cell");
//
//			String linkSource = edge.getSource().getParent().getValue()
//					.toString()
//					+ "@"
//					+ ((ALDPort) edge.getSource().getValue()).getParName();
//			String linkTarget = edge.getTarget().getParent().getValue()
//					.toString()
//					+ "@"
//					+ ((ALDPort) edge.getTarget().getValue()).getParName();
//			ALDOperatorDescriptor opDescrTarget = opDescrMap.get(edge
//					.getTarget().getParent());
//			ALDOpParameterDescriptor descr = opDescrTarget
//					.getParameterDescriptor(((ALDPort) edge.getTarget()
//							.getValue()).getParName());
//
//			if (validateLink(linkSource, linkTarget)) {
//				descr.setLink(true);
//				opDescrTarget.getOperatorControlFrame().changePanel(linkTarget,
//						linkSource);
//				opDescrMap.get(edge.getSource().getParent()).addChild(
//						edge.getTarget().getParent().getValue().toString());
//			} else {
//				opGraph.getModel().remove(edge);
//			}
//		}
//	}

	/**
	 * Context Menu of nodes.
	 */
//	class PopUpMenu extends JPopupMenu implements ActionListener {
//		private mxCell cell;
//
//		public PopUpMenu(int x, int y) {
//			cell = (mxCell) graphComponent.getCellAt(x, y);
//
//			if (cell.isVertex()) {
//				JMenuItem confItem = new JMenuItem("Configure operator");
//				confItem.setActionCommand("conf");
//				confItem.addActionListener(this);
//
//				JMenu runMenu = new JMenu("Run");
//
//				JMenuItem runFlowItem = new JMenuItem("workflow");
//				runFlowItem.setActionCommand("runFlow");
//				runFlowItem.addActionListener(this);
//
//				JMenu runFromMenu = new JMenu("from here");
//				JMenuItem runItem1 = new JMenuItem("with backtracking");
//				runItem1.setActionCommand("run1");
//				runItem1.addActionListener(this);
//				JMenuItem runItem2 = new JMenuItem("without backtracking");
//				runItem2.setActionCommand("run2");
//				runItem2.addActionListener(this);
//				runFromMenu.add(runItem1);
//				runFromMenu.add(runItem2);
//
//				JMenu runNodeMenu = new JMenu("node");
//				JMenuItem runNodeItem1 = new JMenuItem("with backtracking");
//				runNodeItem1.setActionCommand("runNode1");
//				runNodeItem1.addActionListener(this);
//				JMenuItem runNodeItem2 = new JMenuItem("without backtracking");
//				runNodeItem2.setActionCommand("runNode2");
//				runNodeItem2.addActionListener(this);
//				runNodeMenu.add(runNodeItem1);
//				runNodeMenu.add(runNodeItem2);
//
//				runMenu.add(runFlowItem);
//				runMenu.add(runFromMenu);
//				runMenu.add(runNodeMenu);
//
//				JMenuItem showItem = new JMenuItem("Show resultframe");
//				showItem.setActionCommand("show");
//				showItem.addActionListener(this);
//				if (!cell.getStyle().contains("strokeColor=green")) {
//					showItem.setEnabled(false);
//				}
//
//				JMenu copyNodeMenu = new JMenu("Copy node");
//				JMenuItem copyItem1 = new JMenuItem("without configuration");
//				copyItem1.setActionCommand("copyNode1");
//				copyItem1.addActionListener(this);
//				JMenuItem copyItem2 = new JMenuItem("with links");
//				copyItem2.setActionCommand("copyNode2");
//				copyItem2.addActionListener(this);
//				JMenuItem copyItem3 = new JMenuItem("with configuration");
//				copyItem3.setActionCommand("copyNode3");
//				copyItem3.addActionListener(this);
//				copyNodeMenu.add(copyItem1);
//				copyNodeMenu.add(copyItem2);
//				copyNodeMenu.add(copyItem3);
//
//				JMenuItem removeItem = new JMenuItem("Remove node");
//				removeItem.setActionCommand("removeNode");
//				removeItem.addActionListener(this);
//
//				JMenu viewMenu = new JMenu("Viewmode");
//				JMenuItem standardItem = new JMenuItem("Standard");
//				standardItem.setActionCommand("standard");
//				standardItem.addActionListener(this);
//				JMenuItem advancedItem = new JMenuItem("Advanced");
//				advancedItem.setActionCommand("advanced");
//				advancedItem.addActionListener(this);
//				viewMenu.add(standardItem);
//				viewMenu.add(advancedItem);
//
//				this.add(confItem);
//				this.add(runMenu);
//				this.add(showItem);
//				this.addSeparator();
//				this.add(viewMenu);
//				this.add(copyNodeMenu);
//				this.add(removeItem);
//			} else {
//				JMenuItem removeItem = new JMenuItem("Remove edge");
//				removeItem.setActionCommand("removeEdge");
//				removeItem.addActionListener(this);
//				this.add(removeItem);
//			}
//		}
//
//		/**
//		 * Change the mode for displaying parameters.
//		 * 
//		 * @param cell
//		 *            Node with the operator.
//		 * @param handlingMode
//		 *            New handling mode.
//		 */
//		private void changeView(mxCell cell, Parameter.ExpertMode handlingMode) {
//			for (int i = 0; i < cell.getChildCount(); i++) {
//				ALDOpParameterDescriptor descr = opDescrMap.get(cell)
//						.getParameterDescriptor(
//								((ALDPort) cell.getChildAt(i).getValue())
//										.getParName());
//				if (descr.getDirection() == Direction.IN
//						|| descr.getDirection() == Direction.INOUT) {
//					if (handlingMode == Parameter.ExpertMode.STANDARD) {
//						if (descr.getHandlingMode() == handlingMode) {
//							cell.getChildAt(i).setVisible(true);
//						} else {
//							cell.getChildAt(i).setVisible(false);
//						}
//					} else {
//						cell.getChildAt(i).setVisible(true);
//					}
//				}
//			}
//			opGraph.refresh();
//			opDescrMap.get(cell).getOperatorControlFrame()
//					.changeMode(handlingMode);
//		}

//		public void actionPerformed(ActionEvent e) {
//			String command = e.getActionCommand();
//
//			if (command.equals("conf")) {
//				ALDOperatorControlFrame frame = opDescrMap.get(cell)
//						.getOperatorControlFrame();
//				frame.setVisible(true);
//			} else if (command.equals("runFlow")) {
//				runOnlyNode = false;
//				opDescrMap.get(cell).setReverse(true);
//				for (mxCell cell : nodeMap.values()) {
//					int count = 0;
//					for (int i = 0; i < cell.getChildCount(); i++) {
//						Object[] inEdges = opGraph.getIncomingEdges(cell
//								.getChildAt(i));
//						count += inEdges.length;
//					}
//					if (count == 0)
//						runOpNode(cell.getValue().toString(), false);
//				}
//			} else if (command.equals("run1")) {
//				runOnlyNode = false;
//				opDescrMap.get(cell).setReverse(true);
//				runOpNode(cell.getValue().toString(), false);
//			} else if (command.equals("run2")) {
//				runOnlyNode = false;
//				opDescrMap.get(cell).setReverse(false);
//				runOpNode(cell.getValue().toString(), false);
//			} else if (command.equals("runNode1")) {
//				runOnlyNode = true;
//				opDescrMap.get(cell).setReverse(true);
//				runOpNode(cell.getValue().toString(), false);
//			} else if (command.equals("runNode2")) {
//				runOnlyNode = true;
//				opDescrMap.get(cell).setReverse(false);
//				runOpNode(cell.getValue().toString(), false);
//			} else if (command.equals("show")) {
//				ALDOperatorControlFrame frame = opDescrMap.get(cell)
//						.getOperatorControlFrame();
//				frame.showResult();
//			} else if (command.equals("standard")) {
//				changeView(cell, Parameter.ExpertMode.STANDARD);
//			} else if (command.equals("advanced")) {
//				changeView(cell, Parameter.ExpertMode.ADVANCED);
//			} else if (command.equals("copyNode1")) {
//				try {
//					buildNode(cell.getId().split("@")[0], cell.getValue()
//							.toString().split("_")[0], cell.getGeometry()
//							.getX() + 20, cell.getGeometry().getY() + 20);
//				} catch (ALDOperatorException e1) {
//					JOptionPane.showMessageDialog(null, "Copying node \""
//							+ cell.getValue().toString() + "\" failed!"
//							+ " Reason: \n" + e1.getCommentString(), "Warning",
//							JOptionPane.OK_CANCEL_OPTION);
//				}
//			} else if (command.equals("copyNode2")) {
//				try {
//					mxCell copy = buildNode(cell.getId().split("@")[0], cell
//							.getValue().toString().split("_")[0], cell
//							.getGeometry().getX() + 20, cell.getGeometry()
//							.getY() + 20);
//					for (int i = 0; i < cell.getChildCount(); i++) {
//						Object[] inEdges = opGraph.getIncomingEdges(cell
//								.getChildAt(i));
//						if (inEdges.length != 0) {
//							ALDOperatorDescriptor opDescrTarget = opDescrMap
//									.get(copy);
//							ALDOpParameterDescriptor descr = opDescrTarget
//									.getParameterDescriptor(((ALDPort) copy
//											.getChildAt(i).getValue())
//											.getParName());
//							String linkSource = ((mxCell) inEdges[0])
//									.getSource().getParent().getValue()
//									.toString()
//									+ "@"
//									+ ((ALDPort) ((mxCell) inEdges[0])
//											.getSource().getValue())
//											.getParName();
//							String linkTarget = copy.getValue().toString()
//									+ "@"
//									+ ((ALDPort) cell.getChildAt(i).getValue())
//											.getParName();
//							descr.setLink(true);
//							opDescrTarget.getOperatorControlFrame()
//									.changePanel(linkTarget, linkSource);
//							drawEdge(linkSource, linkTarget);
//						}
//					}
//					opGraph.refresh();
//				} catch (ALDOperatorException e1) {
//					JOptionPane.showMessageDialog(null, "Copying node \""
//							+ cell.getValue().toString() + "\" failed!"
//							+ " Reason: \n" + e1.getCommentString(), "Warning",
//							JOptionPane.OK_CANCEL_OPTION);
//				}
//			} else if (command.equals("copyNode3")) {
//				try {
//					mxCell copy = buildNode(cell.getId().split("@")[0], cell
//							.getValue().toString().split("_")[0], cell
//							.getGeometry().getX() + 20, cell.getGeometry()
//							.getY() + 20);
//
//					ALDOperatorDescriptor opDescr1 = opDescrMap.get(cell);
//					ALDOperatorDescriptor opDescr2 = opDescrMap.get(copy);
//
//					opDescr1.getOperatorControlFrame().copyConfiguration(
//							opDescr2.getOperatorControlFrame());
//
//					for (int i = 0; i < cell.getChildCount(); i++) {
//						Object[] inEdges = opGraph.getIncomingEdges(cell
//								.getChildAt(i));
//						if (inEdges.length != 0) {
//							ALDOperatorDescriptor opDescrTarget = opDescrMap
//									.get(copy);
//							ALDOpParameterDescriptor descr = opDescrTarget
//									.getParameterDescriptor(((ALDPort) copy
//											.getChildAt(i).getValue())
//											.getParName());
//							String linkSource = ((mxCell) inEdges[0])
//									.getSource().getParent().getValue()
//									.toString()
//									+ "@"
//									+ ((ALDPort) ((mxCell) inEdges[0])
//											.getSource().getValue())
//											.getParName();
//							String linkTarget = copy.getValue().toString()
//									+ "@"
//									+ ((ALDPort) cell.getChildAt(i).getValue())
//											.getParName();
//							descr.setLink(true);
//							opDescrTarget.getOperatorControlFrame()
//									.changePanel(linkTarget, linkSource);
//							drawEdge(linkSource, linkTarget);
//						}
//					}
//					opGraph.refresh();
//				} catch (ALDOperatorException e1) {
//					JOptionPane.showMessageDialog(null, "Copying node \""
//							+ cell.getValue().toString() + "\" failed!"
//							+ " Reason: \n" + e1.getCommentString(), "Warning",
//							JOptionPane.OK_CANCEL_OPTION);
//				} catch (ALDDataIOException e2) {
//					// TODO Auto-generated catch block
//					e2.printStackTrace();
//				}
//			} else if (command.equals("removeNode")) {
//				for (int i = 0; i < cell.getChildCount(); i++) {
//					Object[] inEdges = opGraph.getIncomingEdges(cell
//							.getChildAt(i));
//
//					if (inEdges.length != 0) {
//						removeEdge((mxCell) inEdges[0], false);
//					}
//
//					Object[] outEdges = opGraph.getOutgoingEdges(cell
//							.getChildAt(i));
//					for (int j = 0; j < outEdges.length; j++) {
//						removeEdge((mxCell) outEdges[j], false);
//					}
//				}
//				opDescrMap.remove(cell);
//				nodeMap.remove(cell.getValue());
//				opGraph.getModel().remove(cell);
//			} else if (command.equals("removeEdge")) {
//				removeEdge(cell, false);
//			}
//		}
//	}
}
