package mitoboRunner;

import ij.IJ;
import ij.plugin.*;



import de.unihalle.informatik.Alida.annotations.indexing.SezPozAdapter;
import de.unihalle.informatik.Alida.exceptions.ALDOperatorException;
import de.unihalle.informatik.Alida.exceptions.ALDProcessingDAGException;
import de.unihalle.informatik.MiToBo.core.gui.editor.MTBEditorFrame;

/**
 * ImageJ plugin for running the Alida/MiToBo graphical editor "Grappa".
 * 
 * @author moeller
 */

public class Grappa_Editor implements PlugIn {

	@Override
  public void run(String arg0) {
		// init the SezPoz adapter properly
		SezPozAdapter.initAdapter(IJ.getClassLoader());
		try {
			// open the editor frame
			MTBEditorFrame eFrame = new MTBEditorFrame();
			eFrame.runOp();
		} catch (ALDOperatorException e) {
			e.printStackTrace();
		} catch (ALDProcessingDAGException e) {
			e.printStackTrace();
		}
	}
}
