/*
 * This file is part of MiToBo, the Microscope Image Analysis Toolbox.
 *
 * Copyright (C) 2010 - 2012
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Fore more information on MiToBo, visit
 *
 *    http://www.informatik.uni-halle.de/mitobo/
 *
 */
/* 
 * Most recent change(s):
 * 
 * $Rev: 6070 $
 * $Date: 2012-10-02 18:08:21 +0200 (Di, 02. Okt 2012) $
 * $Author: moeller $
 * 
 */

package mitoboRunner;

import javax.swing.JOptionPane;

import ij.IJ;
import ij.plugin.*;



import de.unihalle.informatik.Alida.annotations.indexing.SezPozAdapter;
import de.unihalle.informatik.Alida.exceptions.ALDOperatorException;
import de.unihalle.informatik.MiToBo.core.gui.MTBOperatorControlFrame;

/**
 * ImageJ plugin to start the Swing-based Alida/Mitobo operator runner.
 * 
 * @author Stefan Posch 
 * @author Birgit Moeller
 */

public class Snake_Optimizer implements PlugIn {

	@Override
	public void run(String arg0) {
		// init the SezPoz adapter properly
		SezPozAdapter.initAdapter(IJ.getClassLoader());
		// open the control frame
		MTBOperatorControlFrame controlFrame;
		try {
			controlFrame = new MTBOperatorControlFrame(
				"de.unihalle.informatik.MiToBo.segmentation.snakes.optimize.SnakeOptimizerSingleVarCalc");
			controlFrame.setVisible(true);
		} catch (ALDOperatorException e) {
			Object[] okOption = { "OK" };
			JOptionPane.showOptionDialog(
					null, "Problems running Snake_Optimizer...\n"
							+ "Please contact the developers.",
					"Error: cannot run operator!", JOptionPane.DEFAULT_OPTION,
					JOptionPane.ERROR_MESSAGE, null, okOption, okOption[0]);
		}
	}
}
